# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "near-external-storage"
version = "0.34.6"
authors = ["Near Inc <hello@nearprotocol.com>"]
build = false
publish = true
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Common utilities for interacting with external storage backends (S3, GCS, filesystem)"
readme = false
license = "MIT OR Apache-2.0"
repository = "https://github.com/near/nearcore"
resolver = "2"

[package.metadata.cargo-machete]
ignored = ["rust-s3"]

[lib]
name = "near_external_storage"
path = "src/lib.rs"

[dependencies.anyhow]
version = "1.0.62"

[dependencies.futures]
version = "0.3.5"

[dependencies.near-chain-configs]
version = "0.34.6"

[dependencies.object_store]
version = "0.12"
features = ["gcp"]

[dependencies.percent-encoding]
version = "2.2.0"

[dependencies.reqwest]
version = "0.12.0"
features = [
    "blocking",
    "native-tls-vendored",
]

[dependencies.rust-s3]
version = "0.32.3"
features = ["blocking"]

[dependencies.serde]
version = "1.0.136"
features = [
    "alloc",
    "derive",
    "rc",
]

[dependencies.serde_json]
version = "1.0.68"

[dependencies.tracing]
version = "0.1.40"
features = ["std"]

[lints.clippy]
assigning_clones = "deny"
clone_on_copy = "deny"
derivable_impls = "deny"
disallowed_types = "deny"
explicit_deref_methods = "deny"
explicit_into_iter_loop = "deny"
explicit_iter_loop = "deny"
flat_map_option = "deny"
inefficient_to_string = "deny"
large_futures = "deny"
large_stack_frames = "deny"
large_types_passed_by_value = "deny"
len_zero = "deny"
manual_is_variant_and = "deny"
needless_collect = "deny"
needless_pass_by_ref_mut = "deny"
or_fun_call = "deny"
redundant_clone = "deny"
same_functions_in_if_condition = "deny"
single_char_pattern = "allow"
unchecked_duration_subtraction = "deny"
unnecessary_box_returns = "deny"
unnecessary_join = "deny"
unnecessary_lazy_evaluations = "deny"
unused_async = "deny"

[lints.clippy.all]
level = "allow"
priority = -100

[lints.clippy.correctness]
level = "deny"
priority = -50

[lints.clippy.perf]
level = "deny"
priority = -50

[lints.clippy.suspicious]
level = "deny"
priority = -50

[lints.rust.unexpected_cfgs]
level = "allow"
priority = 0
check-cfg = ["cfg(enable_const_type_id)"]
